import sys

import nltk
from nltk.corpus import stopwords

sys.path.append("./../concept-tracker/concept_tracker/utils/")
from tokenizer import spacy_tokenizer

nltk_language = {"en": "English", "es": "Spanish"}

nltk_stop_words = {
    "en": [
        "i",
        "me",
        "my",
        "myself",
        "we",
        "our",
        "ours",
        "ourselves",
        "you",
        "you're",
        "you've",
        "you'll",
        "you'd",
        "your",
        "yours",
        "yourself",
        "yourselves",
        "he",
        "him",
        "his",
        "himself",
        "she",
        "she's",
        "her",
        "hers",
        "herself",
        "it",
        "it's",
        "its",
        "itself",
        "they",
        "them",
        "their",
        "theirs",
        "themselves",
        "what",
        "which",
        "who",
        "whom",
        "this",
        "that",
        "that'll",
        "these",
        "those",
        "am",
        "is",
        "are",
        "was",
        "were",
        "be",
        "been",
        "being",
        "have",
        "has",
        "had",
        "having",
        "do",
        "does",
        "did",
        "doing",
        "a",
        "an",
        "the",
        "and",
        "but",
        "if",
        "or",
        "because",
        "as",
        "until",
        "while",
        "of",
        "at",
        "by",
        "for",
        "with",
        "about",
        "against",
        "between",
        "into",
        "through",
        "during",
        "before",
        "after",
        "above",
        "below",
        "to",
        "from",
        "up",
        "down",
        "in",
        "out",
        "on",
        "off",
        "over",
        "under",
        "again",
        "further",
        "then",
        "once",
        "here",
        "there",
        "when",
        "where",
        "why",
        "how",
        "all",
        "any",
        "both",
        "each",
        "few",
        "more",
        "most",
        "other",
        "some",
        "such",
        "no",
        "nor",
        "not",
        "only",
        "own",
        "same",
        "so",
        "than",
        "too",
        "very",
        "s",
        "t",
        "can",
        "will",
        "just",
        "don",
        "don't",
        "should",
        "should've",
        "now",
        "d",
        "ll",
        "m",
        "o",
        "re",
        "ve",
        "y",
        "ain",
        "aren",
        "aren't",
        "couldn",
        "couldn't",
        "didn",
        "didn't",
        "doesn",
        "doesn't",
        "hadn",
        "hadn't",
        "hasn",
        "hasn't",
        "haven",
        "haven't",
        "isn",
        "isn't",
        "ma",
        "mightn",
        "mightn't",
        "mustn",
        "mustn't",
        "needn",
        "needn't",
        "shan",
        "shan't",
        "shouldn",
        "shouldn't",
        "wasn",
        "wasn't",
        "weren",
        "weren't",
        "won",
        "won't",
        "wouldn",
        "wouldn't",
    ],
    "es": [
        "de",
        "la",
        "que",
        "el",
        "en",
        "y",
        "a",
        "los",
        "del",
        "se",
        "las",
        "por",
        "un",
        "para",
        "con",
        "no",
        "una",
        "su",
        "al",
        "lo",
        "como",
        "más",
        "pero",
        "sus",
        "le",
        "ya",
        "o",
        "este",
        "sí",
        "porque",
        "esta",
        "entre",
        "cuando",
        "muy",
        "sin",
        "sobre",
        "también",
        "me",
        "hasta",
        "hay",
        "donde",
        "quien",
        "desde",
        "todo",
        "nos",
        "durante",
        "todos",
        "uno",
        "les",
        "ni",
        "contra",
        "otros",
        "ese",
        "eso",
        "ante",
        "ellos",
        "e",
        "esto",
        "mí",
        "antes",
        "algunos",
        "qué",
        "unos",
        "yo",
        "otro",
        "otras",
        "otra",
        "él",
        "tanto",
        "esa",
        "estos",
        "mucho",
        "quienes",
        "nada",
        "muchos",
        "cual",
        "poco",
        "ella",
        "estar",
        "estas",
        "algunas",
        "algo",
        "nosotros",
        "mi",
        "mis",
        "tú",
        "te",
        "ti",
        "tu",
        "tus",
        "ellas",
        "nosotras",
        "vosotros",
        "vosotras",
        "os",
        "mío",
        "mía",
        "míos",
        "mías",
        "tuyo",
        "tuya",
        "tuyos",
        "tuyas",
        "suyo",
        "suya",
        "suyos",
        "suyas",
        "nuestro",
        "nuestra",
        "nuestros",
        "nuestras",
        "vuestro",
        "vuestra",
        "vuestros",
        "vuestras",
        "esos",
        "esas",
        "estoy",
        "estás",
        "está",
        "estamos",
        "estáis",
        "están",
        "esté",
        "estés",
        "estemos",
        "estéis",
        "estén",
        "estaré",
        "estarás",
        "estará",
        "estaremos",
        "estaréis",
        "estarán",
        "estaría",
        "estarías",
        "estaríamos",
        "estaríais",
        "estarían",
        "estaba",
        "estabas",
        "estábamos",
        "estabais",
        "estaban",
        "estuve",
        "estuviste",
        "estuvo",
        "estuvimos",
        "estuvisteis",
        "estuvieron",
        "estuviera",
        "estuvieras",
        "estuviéramos",
        "estuvierais",
        "estuvieran",
        "estuviese",
        "estuvieses",
        "estuviésemos",
        "estuvieseis",
        "estuviesen",
        "estando",
        "estado",
        "estada",
        "estados",
        "estadas",
        "estad",
        "he",
        "has",
        "ha",
        "hemos",
        "habéis",
        "han",
        "haya",
        "hayas",
        "hayamos",
        "hayáis",
        "hayan",
        "habré",
        "habrás",
        "habrá",
        "habremos",
        "habréis",
        "habrán",
        "habría",
        "habrías",
        "habríamos",
        "habríais",
        "habrían",
        "había",
        "habías",
        "habíamos",
        "habíais",
        "habían",
        "hube",
        "hubiste",
        "hubo",
        "hubimos",
        "hubisteis",
        "hubieron",
        "hubiera",
        "hubieras",
        "hubiéramos",
        "hubierais",
        "hubieran",
        "hubiese",
        "hubieses",
        "hubiésemos",
        "hubieseis",
        "hubiesen",
        "habiendo",
        "habido",
        "habida",
        "habidos",
        "habidas",
        "soy",
        "eres",
        "es",
        "somos",
        "sois",
        "son",
        "sea",
        "seas",
        "seamos",
        "seáis",
        "sean",
        "seré",
        "serás",
        "será",
        "seremos",
        "seréis",
        "serán",
        "sería",
        "serías",
        "seríamos",
        "seríais",
        "serían",
        "era",
        "eras",
        "éramos",
        "erais",
        "eran",
        "fui",
        "fuiste",
        "fue",
        "fuimos",
        "fuisteis",
        "fueron",
        "fuera",
        "fueras",
        "fuéramos",
        "fuerais",
        "fueran",
        "fuese",
        "fueses",
        "fuésemos",
        "fueseis",
        "fuesen",
        "sintiendo",
        "sentido",
        "sentida",
        "sentidos",
        "sentidas",
        "siente",
        "sentid",
        "tengo",
        "tienes",
        "tiene",
        "tenemos",
        "tenéis",
        "tienen",
        "tenga",
        "tengas",
        "tengamos",
        "tengáis",
        "tengan",
        "tendré",
        "tendrás",
        "tendrá",
        "tendremos",
        "tendréis",
        "tendrán",
        "tendría",
        "tendrías",
        "tendríamos",
        "tendríais",
        "tendrían",
        "tenía",
        "tenías",
        "teníamos",
        "teníais",
        "tenían",
        "tuve",
        "tuviste",
        "tuvo",
        "tuvimos",
        "tuvisteis",
        "tuvieron",
        "tuviera",
        "tuvieras",
        "tuviéramos",
        "tuvierais",
        "tuvieran",
        "tuviese",
        "tuvieses",
        "tuviésemos",
        "tuvieseis",
        "tuviesen",
        "teniendo",
        "tenido",
        "tenida",
        "tenidos",
        "tenidas",
        "tened",
    ],
}


import string


def remove_puctuation(doc):
    doc = doc.translate(str.maketrans("", "", string.punctuation))
    return doc


def return_stopwords(method="nltk", language="en"):
    if method == "nltk":
        return stopwords.words(nltk_language.get(language))


def remove_stopwords_doc(word_list, method="nltk", language="en", extend_stopwords=None):
    if method == "nltk":
        sws = nltk_stop_words.get(language)
        if sws is None:
            nltk.download("stopwords")
            from nltk.corpus import stopwords

            sws = stopwords.words(nltk_language.get(language))
        if extend_stopwords:
            sws.extend(extend_stopwords)

        filtered_words = [word for word in word_list if word not in sws]
    filtered_words = " ".join(filtered_words)
    return filtered_words


def remove(docs, language="en", method="nltk", remove_punct=True, extend_stopwords=None):
    # docs = ['Recovery limbo Anyone else "recovered", but still have an unhealthy relationship with food/body? I\'ve basically been eating maintenance for the past 6 years after a period of quite severe anorexia at 14-ish, but I still feel like I\'ve barely changed. Still feel proud if I skip a meal, feel bad about my body, etc.\n\n&amp;#x200B;\n\nAnyone else in a similar boat? Just feels like it should be better after such a long time I guess.',
    #         'Food is the worst "drug" Hey guys I\'m fat. I\'m a fatty fat and I was just thinking it sucks that you cant quit food. When I eat its like all the dopamine and I cant stop. You can quit smoking or drinking or weed or heroin or meth but not food and that sucks because my relationship with food sucks and I hate it and it sucks. \n\nThanks for coming to my rant I just wanted that off my chest',
    #         "I can't focus on anything but just can't bring myself to eat. So I guess I'm going to fail finals and be one of those freshman fuck ups who should've taken a gap year. I feel consumed by pain. The crippling, falling to your knees type."]
    if remove_punct:
        docs = [remove_puctuation(doc) for doc in docs]

    docs = [doc.lower() for doc in docs]
    docs = spacy_tokenizer(docs, method="word", language="en", lowercase=True)

    filtered_docs = [
        remove_stopwords_doc(word_list, method=method, language=language, extend_stopwords=extend_stopwords)
        for word_list in docs
    ]
    return filtered_docs


"""
docs =  ['i am a boy. How about you?', 'I went to the supermarket']
print(remove(docs, language = 'en', method = 'nltk', remove_punct=True))
"""
